GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
TPG::TPGEdgeInstrumented Class Reference

Instrumented TPGEdge class to keep track of a TPG execution statistics. More...

`#include <tpgEdgeInstrumented.h>`

Inheritance diagram for TPG::TPGEdgeInstrumented:

## Public Member Functions
| TPGEdgeInstrumented (const TPGVertex *src, const TPGVertex *dest, const std::shared_ptr< Program::Program > prog)
| Default constructor.
uint64_t | getNbVisits () const
| Get the number of time a TPGEdge was visited.
void | incrementNbVisits () const
| Add one to the number of visits for this TPGEdge.
uint64_t | getNbTraversal () const
| Get the number of time a TPGEdge was traversed.
void | incrementNbTraversal () const
| Add one to the number of traversal for this TPGEdge.
void | reset () const
| Reset the instrumentation attributes.
Public Member Functions inherited from TPG::TPGEdge
virtual | ~TPGEdge ()=default
| Default virtual destructor (for polymorphism)
| TPGEdge (const TPGVertex *src, const TPGVertex *dest, const std::shared_ptr< Program::Program > prog)
| Main constructor of the TPGEdge class.
Program::Program & | getProgram () const
| Get a const reference to the Program of the TPGEdge.
void | setProgram (const std::shared_ptr< Program::Program > prog) const
| Set a new Program for the TPGEdge.
std::shared_ptr< Program::Program > | getProgramSharedPointer ()
| Get the shared_pointer to the Program.
const TPGVertex * | getSource () const
| Get the source TPGVertex of the TPGEdge.
void | setSource (TPGVertex *newSource)
| Set a new source TPGVertex to the TPGEdge.
virtual const TPGVertex * | getDestination () const
| Get the destination TPGVertex of the TPGEdge.
virtual void | setDestination (TPGVertex *newDestination)
| Set a new destination TPGVertex to the TPGEdge.
virtual uint64_t | getEdgeID () const
| Get the unique identifier of the TPGEdge.
virtual void | setEdgeID (uint64_t newID)
| Set a new unique identifier to the TPGEdge.

## Protected Attributes
std::atomic_uint64_t | nbVisits
std::atomic_uint64_t | nbTraversal
Protected Attributes inherited from TPG::TPGEdge
const TPGVertex * | source
| Pointer to the source TPGVertex of this TPGEdge.
const TPGVertex * | destination
| Pointer to the destination TPGVertex of this TPGEdge.
std::shared_ptr< Program::Program > | program
uint64_t | edgeID
| Unique identifier of the TPGEdge.

## Additional Inherited Members
Static Public Member Functions inherited from TPG::TPGEdge
static uint64_t | getEdgeIDCounter ()
| Get the current value of the edge ID counter.
Protected Member Functions inherited from TPG::TPGEdge
| TPGEdge ()=delete
| Delete the default constructor.
Static Protected Member Functions inherited from TPG::TPGEdge
static uint64_t | incrementeCounter ()
| Incremente the edge ID counter and return the new value.
static void | resetEdgeIDCounter ()
| Reset the edge ID counter.

## Detailed Description

Instrumented TPGEdge class to keep track of a TPG execution statistics.

## Member Function Documentation

## ◆ getNbTraversal()

uint64_t TPG::TPGEdgeInstrumented::getNbTraversal | ( |  | ) | const

Get the number of time a TPGEdge was traversed.

That is the number of time its program produced the winning bid.

## ◆ getNbVisits()

uint64_t TPG::TPGEdgeInstrumented::getNbVisits | ( |  | ) | const

Get the number of time a TPGEdge was visited.

That is the number of time it caused an execution of its program.

Copyright or © or Copr. IETR/INSA - Rennes (2022) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2022)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

## Member Data Documentation

## ◆ nbTraversal

std::atomic_uint64_t TPG::TPGEdgeInstrumented::nbTraversal
| mutable protected

Number of a time a TPGEdge has been traversed That is the number of time its program produced the winning bid. Attribute is mutable because all TPGEdge are seen as const outside from their TPGGraph.

## ◆ nbVisits

std::atomic_uint64_t TPG::TPGEdgeInstrumented::nbVisits
| mutable protected

Number of a time a TPGEdge has been visited That is the number of time it caused an execution of its program. Attribute is mutable because all TPGEdge are seen as const outside from their TPGGraph.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/tpg/instrumented/tpgEdgeInstrumented.h
- D:/a/gegelati/gegelati/gegelatilib/src/tpg/instrumented/tpgEdgeInstrumented.cpp